From e89b6ae12a4970d5f53b5c84c8b56a2da3c5cdee Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Fri, 18 Oct 2024 20:47:57 +0300
Subject: [PATCH 41/41] Refresh gnulib .m4 files

Upstream has added an "offered as-is" -comment to them.

See RM #979

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 dependencies/m4/gnulib-common.m4 | 1 +
 dependencies/m4/locale-en.m4     | 1 +
 dependencies/m4/mkstemp.m4       | 1 +
 dependencies/m4/stdlib_h.m4      | 1 +
 m4/build-to-host.m4              | 1 +
 m4/codeset.m4                    | 6 ++++--
 m4/gettext.m4                    | 1 +
 m4/host-cpu-c-abi.m4             | 1 +
 m4/iconv.m4                      | 1 +
 m4/intlmacosx.m4                 | 1 +
 m4/lib-ld.m4                     | 1 +
 m4/lib-link.m4                   | 1 +
 m4/lib-prefix.m4                 | 1 +
 m4/nls.m4                        | 1 +
 m4/progtest.m4                   | 1 +
 15 files changed, 18 insertions(+), 2 deletions(-)

diff --git a/dependencies/m4/gnulib-common.m4 b/dependencies/m4/gnulib-common.m4
index 1fec5c5ce1..6981dcae81 100644
--- a/dependencies/m4/gnulib-common.m4
+++ b/dependencies/m4/gnulib-common.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 2007-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 
 AC_PREREQ([2.62])
 
diff --git a/dependencies/m4/locale-en.m4 b/dependencies/m4/locale-en.m4
index 39d08a23b0..a194894a43 100644
--- a/dependencies/m4/locale-en.m4
+++ b/dependencies/m4/locale-en.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 2003-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 
 dnl From Bruno Haible.
 
diff --git a/dependencies/m4/mkstemp.m4 b/dependencies/m4/mkstemp.m4
index 311e6afd45..e2a40b82a9 100644
--- a/dependencies/m4/mkstemp.m4
+++ b/dependencies/m4/mkstemp.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 2001, 2003-2007, 2009-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 
 # On some hosts (e.g., HP-UX 10.20, SunOS 4.1.4, Solaris 2.5.1), mkstemp has a
 # silly limit that it can create no more than 26 files from a given template.
diff --git a/dependencies/m4/stdlib_h.m4 b/dependencies/m4/stdlib_h.m4
index 5d9b3017c4..68d98427b5 100644
--- a/dependencies/m4/stdlib_h.m4
+++ b/dependencies/m4/stdlib_h.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 2007-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 
 AC_DEFUN_ONCE([gl_STDLIB_H],
 [
diff --git a/m4/build-to-host.m4 b/m4/build-to-host.m4
index c416bca325..d13649e0c5 100644
--- a/m4/build-to-host.m4
+++ b/m4/build-to-host.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 2023-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 
 dnl Written by Bruno Haible.
 
diff --git a/m4/codeset.m4 b/m4/codeset.m4
index eb7326013d..69c7046f94 100644
--- a/m4/codeset.m4
+++ b/m4/codeset.m4
@@ -1,9 +1,11 @@
-# codeset.m4 serial 5 (gettext-0.18.2)
-dnl Copyright (C) 2000-2002, 2006, 2008-2014, 2016, 2019-2022 Free Software
+# codeset.m4
+# serial 5 (gettext-0.18.2)
+dnl Copyright (C) 2000-2002, 2006, 2008-2014, 2016, 2019-2024 Free Software
 dnl Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 
 dnl From Bruno Haible.
 
diff --git a/m4/gettext.m4 b/m4/gettext.m4
index c8580c95fa..0675885e05 100644
--- a/m4/gettext.m4
+++ b/m4/gettext.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 1995-2014, 2016, 2018-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 dnl
 dnl This file can be used in projects which are not available under
 dnl the GNU General Public License or the GNU Lesser General Public
diff --git a/m4/host-cpu-c-abi.m4 b/m4/host-cpu-c-abi.m4
index 80a8366855..ca021d6a9e 100644
--- a/m4/host-cpu-c-abi.m4
+++ b/m4/host-cpu-c-abi.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 2002-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 
 dnl From Bruno Haible and Sam Steingold.
 
diff --git a/m4/iconv.m4 b/m4/iconv.m4
index b414bfca62..dc57b456ed 100644
--- a/m4/iconv.m4
+++ b/m4/iconv.m4
@@ -5,6 +5,7 @@ dnl Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 
 dnl From Bruno Haible.
 
diff --git a/m4/intlmacosx.m4 b/m4/intlmacosx.m4
index 36b4eb62b7..4cf791673b 100644
--- a/m4/intlmacosx.m4
+++ b/m4/intlmacosx.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 2004-2014, 2016, 2019-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 dnl
 dnl This file can be used in projects which are not available under
 dnl the GNU General Public License or the GNU Lesser General Public
diff --git a/m4/lib-ld.m4 b/m4/lib-ld.m4
index 5da3eecfc6..e6e16bb0b5 100644
--- a/m4/lib-ld.m4
+++ b/m4/lib-ld.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 1996-2003, 2009-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 
 dnl Subroutines of libtool.m4,
 dnl with replacements s/_*LT_PATH/AC_LIB_PROG/ and s/lt_/acl_/ to avoid
diff --git a/m4/lib-link.m4 b/m4/lib-link.m4
index fb764d3229..d32930ee5d 100644
--- a/m4/lib-link.m4
+++ b/m4/lib-link.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 2001-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 
 dnl From Bruno Haible.
 
diff --git a/m4/lib-prefix.m4 b/m4/lib-prefix.m4
index 6277f72d0c..cf72a5b481 100644
--- a/m4/lib-prefix.m4
+++ b/m4/lib-prefix.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 2001-2005, 2008-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 
 dnl From Bruno Haible.
 
diff --git a/m4/nls.m4 b/m4/nls.m4
index 219cbaa136..a96b7ab67d 100644
--- a/m4/nls.m4
+++ b/m4/nls.m4
@@ -5,6 +5,7 @@ dnl Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 dnl
 dnl This file can be used in projects which are not available under
 dnl the GNU General Public License or the GNU Lesser General Public
diff --git a/m4/progtest.m4 b/m4/progtest.m4
index 65ec1942ab..5188673fe7 100644
--- a/m4/progtest.m4
+++ b/m4/progtest.m4
@@ -4,6 +4,7 @@ dnl Copyright (C) 1996-2003, 2005, 2008-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
+dnl This file is offered as-is, without any warranty.
 dnl
 dnl This file can be used in projects which are not available under
 dnl the GNU General Public License or the GNU Lesser General Public
-- 
2.45.2